#pragma semicolon 1
#include <sourcemod>
#include <sdktools>
#include <dhooks>

#define VERSION "1.0"

public Plugin myinfo = 
{
	name = "SetHealth Fix",
	author = "gurg",
	description = "Adds a stamina penalty to SetHealth to emulate earlier CS:GO builds",
	version = VERSION,
	url = "nope.nope"
}


// bool CBaseEntity::AcceptInput(char  const*, CBaseEntity*, CBaseEntity*, variant_t, int)
Handle hAcceptInput;

Handle hConVar_Penalty;
float fPenalty = 0.0;

public void OnPluginStart()
{
	Handle hTemp = LoadGameConfigFile("sdktools.games");
	
	if(hTemp == INVALID_HANDLE)
	{
		SetFailState("What, like this is actually impressive, you don't have SDKTools?");
	}
	
	int iOffset = GameConfGetOffset(hTemp, "AcceptInput");
	hAcceptInput = DHookCreate(iOffset, HookType_Entity, ReturnType_Bool, ThisPointer_CBaseEntity, AcceptInput);
	DHookAddParam(hAcceptInput, HookParamType_CharPtr);
	DHookAddParam(hAcceptInput, HookParamType_CBaseEntity);
	DHookAddParam(hAcceptInput, HookParamType_CBaseEntity);
	DHookAddParam(hAcceptInput, HookParamType_Object, 20, DHookPass_ByVal|DHookPass_ODTOR|DHookPass_OCTOR|DHookPass_OASSIGNOP); //varaint_t is a union of 12 (float[3]) plus two int type params 12 + 8 = 20
	DHookAddParam(hAcceptInput, HookParamType_Int);
	
	CloseHandle(hTemp);
	
	hConVar_Penalty = CreateConVar("sm_sethealth_velmod", "0.4", "Velocity modifier applied when SetHealth is used", 0, true, 0.0, true, 100.0);
	fPenalty = GetConVarFloat(hConVar_Penalty);
	HookConVarChange(hConVar_Penalty, OnPenaltyChanged);
}

public void OnPenaltyChanged(Handle cvar, const char[] oldVal, const char[] newVal)
{
	fPenalty = StringToFloat(newVal);
}

public MRESReturn AcceptInput(int pThis, Handle hReturn, Handle hParams)
{
	if ((0 >= pThis || pThis > MaxClients) || !IsValidEntity(pThis) || !IsClientConnected(pThis) || !IsClientInGame(pThis) || !IsPlayerAlive(pThis))
		return MRES_Ignored;
		
	if(DHookIsNullParam(hParams, 1))
		return MRES_Ignored;
		
	char sInput[128];
	DHookGetParamString(hParams, 1, sInput, sizeof(sInput));
	if(StrEqual(sInput,"SetHealth",false))
	{
		static char sParam[32];
		DHookGetParamObjectPtrString(hParams, 4, 0, ObjectValueType_String, sParam, sizeof(sParam));
		
		int iNewHealth = StringToInt(sParam);
		
		if(GetEntProp(pThis, Prop_Send, "m_iHealth") > iNewHealth)
		{
			SetEntPropFloat(pThis, Prop_Send, "m_flVelocityModifier", fPenalty);
		}
	}
	return MRES_Ignored;
}

public void OnClientPutInServer(int client)
{
	if(0 < client <= MaxClients && hAcceptInput != INVALID_HANDLE && IsValidEntity(client) && IsClientConnected(client) && IsClientInGame(client))
		DHookEntity(hAcceptInput, false, client);
}